﻿@using Business.Repository.IRepository
@using Models.RoundData
@using Models.CompetitionData
@inject IModalDialogService ModalDialog
@inject IJSRuntime JsRuntime
@inject IRoundRepository RoundRepository
@inject ICompetitionRepository CompetitionRepository
@inject NavigationManager NavigationManager

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Round</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@RoundModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Sport</label>
                        <InputText @bind-Value="CurrentCompetition.Name" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="RoundModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => RoundModel.Name" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title Round</button>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>


@code {
    [Parameter]
    public int? RoundId { get; set; }
    [Parameter]
    public int? CompetitionId { get; set; }
    [CascadingParameter]
    BlazoredModalInstance ModalInstance { get; set; }


    private RoundDTO RoundModel { get; set; } = new RoundDTO();
    private string Title { get; set; } = "Create";
    private CompetitionDTO CurrentCompetition { get; set; } = new CompetitionDTO();

    protected override async Task OnInitializedAsync()
    {
        CurrentCompetition = await CompetitionRepository.Get(CompetitionId.Value);
        if (RoundId != null)
        {
            //update
            Title = "Update";
            RoundModel = await RoundRepository.Get(RoundId.Value);
        }
        else
        {
            //create
            RoundModel = new RoundDTO();
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            //create

            if (RoundModel.Id != 0 && Title == "Update")
            {
                //update
                var updateRound = await RoundRepository.Update(RoundModel, RoundModel.Id);
                await JsRuntime.ToastrSuccess("Round updated successfully");
                await Task.Delay(300);
                ModalDialogParameters returnParameters = new ModalDialogParameters();
                ModalDialog.Close(true, returnParameters);
            }
            else
            {
                //create
                RoundModel.CompetitionId = CurrentCompetition.Id;
                var createdResult = await RoundRepository.Create(RoundModel);

                await JsRuntime.ToastrSuccess("Round created successfully");
                await Task.Delay(300);
                ModalDialogParameters returnParameters = new ModalDialogParameters();
                ModalDialog.Close(true, returnParameters);
            }
        }
        catch (Exception ex)
        {
            throw ex;

        }
    }
}
